<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs.qdoc -->
  <title>Introduction | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Introduction</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="index.html" />
  <link rel="next" href="setup.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="index.html">Qbs Manual</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="setup.html">Setup</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#features">Features</a></li>
<li class="level2"><a href="#declarative-paradigm">Declarative Paradigm</a></li>
<li class="level2"><a href="#well-defined-language">Well-Defined Language</a></li>
<li class="level2"><a href="#platform-and-programming-language-independence">Platform and Programming Language Independence</a></li>
<li class="level2"><a href="#correct-and-fast-incremental-builds">Correct and Fast Incremental Builds</a></li>
<li class="level2"><a href="#extensible-architecture">Extensible Architecture</a></li>
<li class="level2"><a href="#ide-integration">IDE Integration</a></li>
<li class="level1"><a href="#build-process">Build Process</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Introduction</h1>
<span class="subtitle"></span>
<!-- $$$overview.html-description -->
<div class="descr"> <a name="details"></a>
<p>Qbs is a build automation tool designed to conveniently manage the build process of software projects across multiple platforms.</p>
<a name="features"></a>
<h2 id="features">Features</h2>
<p>Qbs provides the following benefits:</p>
<ul>
<li>Declarative paradigm</li>
<li>Well-defined language</li>
<li>Platform and programming language independence</li>
<li>Correct and fast incremental builds</li>
<li>Extensible architecture</li>
<li>Easy integration to IDEs</li>
</ul>
<a name="declarative-paradigm"></a>
<h3 id="declarative-paradigm">Declarative Paradigm</h3>
<p>When writing a project, it is important to describe the build tasks and dependencies between them, rather than the build order. It is difficult to determine the correct build order in complex projects, especially during parallel builds. The build tool should bear that burden, not the developer.</p>
<p>With a declarative language, Qbs enables you to express intent rather than specifying single build steps. This provides the appropriate level of abstraction for a build system. For example, <i>dependencies</i> can be created between <i>products</i>, such that the target <i>artifacts</i> of the dependency can be used as input to the build <i>rules</i> in the context of the depending product. In addition, you can <i>export</i> dependencies and <i>properties</i> to other products.</p>
<p>Qbs is modular with clean interfaces between modules. A <i>module</i> is a collection of properties and <i>language items</i> that are used for building a product if the product depends on the module. The properties that can be set for a module are used to control the behavior of the toolchain used to build the module.</p>
<p>Qbs itself knows nothing about file types or extensions, and therefore all source files in a product are handled equally. However, you can assign <i>file tags</i> to an artifact to act as markers or to specify a file type. Qbs applies a rule to the source files of the project and chooses the ones that match the input file tags specified by the rule. It then creates artifacts in the build graph that have other filenames and file tags.</p>
<p>Products and projects can contain <i>probes</i> that are run prior to building, for instance to locate dependent headers, libraries, and other files outside the project directory.</p>
<a name="well-defined-language"></a>
<h3 id="well-defined-language">Well-Defined Language</h3>
<p>Qbs projects are specified in a QML dialect. QML is a concise, easy to learn, and intuitive language that is used successfully in the Qt project. Its core is declarative, but it can be extended with JavaScript snippets for extra flexibility.</p>
<p>Qbs builds applications based on the information in a project file. Each project file specifies one <a href="qml-qbslanguageitems-project.html">project</a> that can contain several <a href="qml-qbslanguageitems-product.html">products</a>. You specify the type of the product, such as an <i>application</i>, and the dependencies the product has on other products.</p>
<p>The product type determines the set of <a href="qml-qbslanguageitems-rule.html">rules</a> that Qbs applies to produce artifacts from input files. The input files can be divided into <a href="qml-qbslanguageitems-group.html">groups</a> according to their type or purpose, for example. A group can also be used to attach <a href="commands.html#properties">properties</a> to products.</p>
<p>The following is an example of a minimal project file that specifies the product type, application name, source file, and a dependency on the <a href="qml-qbsmodules-cpp.html">cpp</a> module:</p>
<pre class="cpp">

  Application {
      name: <span class="string">&quot;helloworld&quot;</span>
      files: <span class="string">&quot;main.cpp&quot;</span>
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
  }

</pre>
<p>For more information, see <a href="language-introduction.html">Language Introduction</a>.</p>
<a name="platform-and-programming-language-independence"></a>
<h3 id="platform-and-programming-language-independence">Platform and Programming Language Independence</h3>
<p>Qbs can be used for any software project, regardless of programming language, toolkit, or libraries used. Qbs has built-in support for building applications for Windows, Linux, <a href="nolink">macOS</a>, Android, iOS, tvOS, watchOS, QNX, and FreeBSD, as well as for cross-compilation. It can be easily extended to support further platforms.</p>
<p>Invoking <a href="cli-build.html">qbs build</a> from the command line automatically builds the project for the current host platform using the best available toolchain and settings, unless a default profile is set. You can configure additional profiles for each toolchain you want to use and select the profile to use at build time.</p>
<p>For example, to build applications for Android devices, you would need to set up a profile for the Android toolchain and select it when you build the application. If you name the profile <i>Android</i>, you would then enter the following command:</p>
<pre class="cpp">

  qbs build profile:Android

</pre>
<p>For more information, see <a href="building-applications.html">Building Applications</a>.</p>
<p>Platform and programming language support is implemented as a set of <a href="qbsmodules-qmlmodule.html">modules</a> that your product depends on. In the language example above, the dependency on the <a href="qml-qbsmodules-cpp.html">cpp</a> module determines that the C++ sources are compiled and linked into a binary.</p>
<p>Alternatively, you could use the <a href="qml-qbsconvenienceitems-cppapplication.html">CppApplication</a> convenience item that implies a dependency on the <a href="qml-qbsmodules-cpp.html">cpp</a> module:</p>
<pre class="cpp">

  CppApplication {
      name: <span class="string">&quot;helloworld&quot;</span>
      files: <span class="string">&quot;main.cpp&quot;</span>
  }

</pre>
<p>Additionally, if the sources use Qt, you need a dependency to the <a href="qml-qbsmodules-qt-core.html">Qt.core</a> module, and so on.</p>
<p>In addition to building projects, Qbs can install the build artifacts to a location from where they can be run on the desktop or on a device. Qbs modules can be used to create installers for the end users of the applications. For example, the <a href="qml-qbsmodules-dmg.html">dmg</a> module contains properties and rules for building Apple Disk Images, which are typically used to distribute applications and installers on <a href="nolink">macOS</a>. The <a href="qml-qbsmodules-innosetup.html">innosetup</a>, <a href="qml-qbsmodules-nsis.html">nsis</a>, and <a href="qml-qbsmodules-wix.html">wix</a> modules contain properties and rules for building installers for Windows platforms.</p>
<a name="correct-and-fast-incremental-builds"></a>
<h3 id="correct-and-fast-incremental-builds">Correct and Fast Incremental Builds</h3>
<p>Qbs is an all-in-one tool that generates a build graph from a high-level project description (like qmake or CMake) and additionally undertakes the task of executing the commands in the low-level build graph (like make).</p>
<p>Qbs automatically takes advantage of multi-processor and multi-core systems to achieve maximum build parallelization. By default, running <code>qbs</code> without any arguments is roughly equivalent to running <code>make -j&lt;n&gt;</code> where <code>n</code> is the number of CPU cores. Similarly, Qbs allows the number of concurrent jobs to be explicitly specified using its own <code>-j</code> option.</p>
<p>Qbs has knowledge about the whole project, and therefore builds remain correct even when you build sub-projects, because Qbs ensures that all dependencies are built too. This virtually eliminates the need for clean builds.</p>
<p>Qbs uses dynamic build graphs with build rules that can generate a variable number of files and that are executed only when needed. When figuring out which rules to execute, Qbs starts at the product type and then looks for a way to produce artifacts with matching file tags from source files, using a chain of rules that are connected by their respective input and output tags. For an example of how rules are applied when building products, see <a href="qml-qbslanguageitems-rule.html#rules-and-product-types">Rules and Product Types</a>.</p>
<p>The Qbs build rules can produce a variable number of outputs. If the input changes, only the required rules are applied at build time. If a rule is applied, all the dependent rules are applied as well, but only those. This feature ensures the correctness of the build graph after source code changes without having to re-configure the whole project.</p>
<p>Changing properties that do not affect the build, because they are not used by rules, will not cause the project to be rebuilt. The use of properties is tracked. Generated artifacts that cease to exist are deleted to avoid picking outdated generated artifacts and indefinitely increasing the size of the build directory.</p>
<p>Fast incremental builds are crucial for a fast edit-build-run cycle. Instead of retrieving the timestamps of generated files, Qbs uses the time stamps stored in the build graph. This is especially important on Windows, where file system operations are slow.</p>
<p>If the project files were not changed, the build graph is loaded from disk. It is stored in a binary format that can be loaded much faster than the real project files. The project files are parsed only if they were changed.</p>
<a name="extensible-architecture"></a>
<h3 id="extensible-architecture">Extensible Architecture</h3>
<p>You can create your own custom <a href="qbsmodules-qmlmodule.html">modules</a> and <a href="qbslanguageitems-qmlmodule.html">items</a> and make Qbs aware of them.</p>
<p>You store the custom modules and items in a subdirectory of the project directory and specify the path to the subdirectory as a value of the <a href="qml-qbslanguageitems-project.html#qbsSearchPaths-prop">qbsSearchPaths</a> property. For example, if the custom module is located at <code>my-modules/modules/modulename/modulename.qbs</code>, you would specify it in the project file as follows:</p>
<pre class="cpp">

  Project {
      qbsSearchPaths: <span class="string">&quot;my-modules&quot;</span>

</pre>
<p>For more information, see <a href="custom-modules.html">Custom Modules and Items</a>.</p>
<a name="ide-integration"></a>
<h3 id="ide-integration">IDE Integration</h3>
<p>Qbs can be used not only from the command line, but also in combination with an IDE, such as Qt Creator, Microsoft Visual Studio, or Xcode. Qt Creator directly supports Qbs projects. Visual Studio and Xcode users can use Qbs to generate Microsoft Visual Studio and Xcode projects. For more information, see <a href="generators.html">Generators</a>.</p>
<a name="qt-creator"></a>
<h4 id="qt-creator">Qt Creator</h4>
<p><a href="http://doc.qt.io/qtcreator/index.html">Qt Creator</a> uses the same Qbs library as the Qbs command line tools. Therefore, it can retrieve all the information required to build a single file or project through a defined public API. Qt Creator provides accurate information about the build progress and displays a project tree that reflects the logical structure of the project, instead of presenting low-level information, such as the file system structure. Adding or removing source files keeps the existing project file structure intact.</p>
<p>For more information about using Qbs to build projects from Qt Creator, see <a href="http://doc.qt.io/qtcreator/creator-project-qbs.html">Setting Up Qbs</a>.</p>
<a name="build-process"></a>
<h2 id="build-process">Build Process</h2>
<p class="centerAlign"><img src="images/qbs-build-process.png" alt="" /></p><p>The build process of a product starts by examining the <a href="qml-qbslanguageitems-product.html#type-prop">type</a> property of the product. It contains a list of <i>file tags</i> that are similar to MIME types.</p>
<p>The following example product contains one file tag, <i>application</i>:</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      type: <span class="operator">[</span><span class="string">&quot;application&quot;</span><span class="operator">]</span>
      files: <span class="operator">[</span><span class="string">&quot;main.cpp&quot;</span><span class="operator">,</span> <span class="string">&quot;class.cpp&quot;</span><span class="operator">,</span> <span class="string">&quot;class.h&quot;</span><span class="operator">]</span>
  }

</pre>
<p>Qbs then searches through all <i>rules</i> available in the context, meaning rules that are defined in the project or those that are made available through the dependency on a module, such as the compiler and linker rules pulled in from the <code>cpp</code> dependency in the example.</p>
<p>When Qbs finds a rule that produces one or more artifacts with the relevant file tag, it looks at the depencencies of that rule and finds out that it produces artifacts tagged <code>obj</code>. It then finds a rule that produces <code>obj</code> artifacts that takes <code>.cpp</code> artifacts as input.</p>
<pre class="cpp">

  Module {
      <span class="comment">// ...</span>
      Rule {
          inputs {<span class="string">&quot;cpp&quot;</span><span class="operator">]</span>
          Artifact <span class="operator">[</span>
              filePath: input<span class="operator">.</span>fileName <span class="operator">+</span> <span class="string">&quot;.o&quot;</span>
              fileTags: {<span class="string">&quot;obj&quot;</span><span class="operator">]</span>
          }
          prepare: <span class="operator">[</span>
              <span class="comment">// g++ -c main.cpp -o main.o ...</span>
          }
      }
      <span class="comment">//...</span>
  }

</pre>
<p>There is no rule in the current context that produces <code>.cpp</code> files, but we have defined <code>.cpp</code> files as inputs for the product. When we added a dependency on the <a href="qml-qbsmodules-cpp.html">cpp</a> module, that dependency also pulled in another Qbs primitive called the <a href="qml-qbslanguageitems-filetagger.html">file tagger</a>. The file tagger looked for files matching the pattern <code>*.cpp</code>, and then applied the <code>cpp</code> tag to those input files:</p>
<pre class="cpp">

  Module {
      <span class="comment">// ...</span>
      FileTagger {
          patterns: <span class="string">&quot;*.cpp&quot;</span>
          fileTags: <span class="operator">[</span><span class="string">&quot;cpp&quot;</span><span class="operator">]</span>
      }
      <span class="comment">//...</span>
  }

</pre>
<p>Since the <code>.cpp</code> files are input files, they by definition have no other dependencies, and we can go back the opposite way in the tree starting with the compiler rule described above.</p>
<p>This design works well for generated files. The <code>.cpp</code> artifacts could come from another rule that produced them by processing some other input, either instead of or in addition to the raw files listed in the product.</p>
<p>The compiler rule will be invoked twice, once for each <code>.cpp</code> file, producing a separate object file for each one. Then the linker rule will be invoked. Its <code>multiplex</code> property is set to <code>true</code>, which means that instead of producing one output per input and invoking the rule multiple times, all input will be collected before invoking the rule only once to produce the final application object.</p>
<p>The standard versus multiplex rules map well to the compiler and linker processes. The compiler takes one input file to produce one output file, whereas the linker takes multiple input files to produce one output file.</p>
<p>Finally, after the linker rule has been invoked, it produces an artifact tagged <code>application</code>. Because the product's type property did not contain other file tags, the build process is now complete.</p>
</div>
<!-- @@@overview.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="index.html">Qbs Manual</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="setup.html">Setup</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
